var GlobalSpace = {
	json_debug: 0,
	dataurl:"/goform/mainBoard",
	page_id:3,
	ip_num:2,
	ip_p_num: 80,
	asi_p_num: 4,
	mux_num:4,
	//DEF_TSOIP_NET:19,
	//DEF_TSOIP_MODE:20,
	DefaultFormId:34,

	BOARD_INFO:{},
	INIT:{},
	VERSION:{},
	in_s_cobj:{ 
		BOARD_INFO: {form_id: 6}
	},	
	mybusy_data:loadvalue(),
	def_ajax_para:{
		bk_fn:ajaxBk_before,
		bkrm_fn:ajaxBk_end
	}
};

var DEF={
	AJAX_BK:{
		DEFAULT:0,
		LOAD:1,
		NO:2,

		REMOVE2:255
	},
	SEND_TYPE:{
		GIVE:0,
		GET:1
	}
};

var barInfo = {
	basicInfos:{
		siteID:"rebootID",
		rTime:1000,
		modeStyle:"rectangle",
		isAjaxGetTime:false,
		isModal:false
	},
	styleInfos:{
		rGeoPostion:"relative",
		rGeoLocation:["0px","0px","0px","0px"],
		rWidth:"340px",
		rHeight:"30px",

		rBorderRadius:"10px",
		//span
		procColor:"red",
		procFontSize:"13px",
		procBgColor:"#03B40A"
	},
	timeData:{
		bgToalTime:0
	}
};
function pad(num, n){
	return n>num.length?(Array(n).join('0') + num).slice(-n):num;
}
function ajaxBk_before(bk_type){
	var G = GlobalSpace;

	switch(bk_type){
		case DEF.AJAX_BK.DEFAULT:
			G.mybusy_data.settext();
			break;
		case DEF.AJAX_BK.LOAD:
			G.mybusy_data.loadsth();
			break;
		case DEF.AJAX_BK.NO:
			break;
		default:
			G.mybusy_data.settext();
			break;
	}
}
function ajaxBk_end(bk_type){
	var G = GlobalSpace;

	switch(bk_type){
		case DEF.AJAX_BK.REMOVE2:
			G.mybusy_data.remove2();
			break;
		default:
			G.mybusy_data.remove();
			break;
	}
}
function apply_callback(type,data){
	console.log(type);
	switch(type){

		case 36:
			alert("Reboot modules successfully!");
			break;
		default:
			break;
	}
}

function ajax_func_handler(data, fn, ajax_para){
	switch(ajax_para.type){
		case DEF.SEND_TYPE.GIVE:
			fn(ajax_para.form_id,data);
			break;
	}
}

function ajaxWrap(jsonStr, fn, ajax_para){
	$.ajax({
		dataType: "json",
		type: 'POST',
		url:GlobalSpace.dataurl+'?id='+GlobalSpace.page_id,
		data:{json:jsonStr},
		beforeSend:function(XMLHttpRequest){
			mybusy = loadvalue();
			mybusy.settext();
		},
		success: function(data){
			mybusy.remove();
			ajax_func_handler(data, fn, ajax_para);
		},
		error: function(data){
			mybusy.remove();
		}
	});
}

function applyResetSonBoard() {
	var	ajax_para={},
		jsonStr = "",
		json_obj=
		{
			RESETSON:
			{
				form_id: 36,
				value:[]
			}

		};
	var selValue = $("#selRetSon").multiselect("MyValues").split(",.")[0].split(",");
	for(var i=0;i<selValue.length;i++)
	{
		json_obj.RESETSON.value.push(parseInt(selValue[i]));
	}

	jsonStr = $.toJSON(json_obj);
	console.log(jsonStr);

	ajax_para.form_id = json_obj.RESETSON.form_id;
	ajax_para.type = DEF.SEND_TYPE.GIVE;
	ajaxWrap(jsonStr, apply_callback, ajax_para);
}
/*flag=1 reboot; flag=2 default */
function setup_reboot(flag){
	if(flag == 1) {
		var r = confirm("Do you want to restart the device?");
		if(r == false)
		{
			return false;
		}
		barInfo.basicInfos.siteID = "rebootID" ;
	}
	var G=Global;
	G.def_ajax_para.url	= '/goform/reboot';

	$.ajax({
		dataType: "json",
		type: 'POST',
		url:G.def_ajax_para.url,
		data:{json:''},
		success: function(data){
			if(parseInt(flag) == 2)
			{
				barInfo.basicInfos.siteID = "defaultBar" ;
				$("#common_confirm_model .modal-header .title").html("Device is restarting. Please wait a moment...");
				$("#common_confirm_model .modal-footer .ok").attr("disabled",true);
				$("#defaultBar").show();
				$("#prompts").hide();
			}
			//console.log(GlobalSpace.INIT.value.max_uptime);
			barInfo.timeData.bgToalTime = (parseInt(GlobalSpace.INIT.value.max_uptime)>0 && GlobalSpace.INIT.value.max_uptime!=undefined)?GlobalSpace.INIT.value.max_uptime:0;
			//barInfo.timeData.bgToalTime = 12000;
			//console.log(barInfo.timeData.bgToalTime);
			ProcessBar.creat(barInfo);
		},
		error: function(data){
			var errormsg='';
			if(flag ==1)
			{
				errormsg = "Reboot";
			}else if(flag == 2)
			{
				errormsg = "Default";
			}
			console.log(errormsg+" process bar error !");
		}
	});
}
function applyTypePara(apply_type_form_id)
{
	var	jsonStr = "",
		json_obj=
		{
			DATA:
			{
				form_id: parseInt(apply_type_form_id)
			}

		};
	jsonStr = $.toJSON(json_obj);
	$.ajax({
		dataType: "json",
		type: 'POST',
		url:GlobalSpace.dataurl+'?id='+GlobalSpace.page_id,
		data:{json:jsonStr},
		success: function(data){
			setup_reboot(2);
		},
		error: function(data){ console.log("Oh Oh Error!");}
	});
}

function onInitReceived(para){
	var G=GlobalSpace,
		P=para,
		obj_temp = null;
		num_temp = 0,
		str_temp = "",
		tr="";
		i = 0,
		j = 0,
		value=[];

	GlobalSpace.INIT = para.INIT;
	VERSION_value = para.VERSION.value;
	$('#ser_num').html(GlobalSpace.INIT.value.SN);
	$('#mainver').html(pad(VERSION_value.main_ver.toString(16), 4));
	$('#kernel_ver').html(pad(VERSION_value.kernel_ver.toString(16), 4));
	$('#fpgaver').html(pad(VERSION_value.FGPA_ver.toString(16), 4));
	$('#web_version').html(pad(VERSION_value.web_ver.toString(16), 4));
	$('#app_version').html(pad(VERSION_value.APP_ver.toString(16), 4));
	$('#firm_version').html(pad(VERSION_value.firm_ver.toString(16), 4));
}
function init_system(){
	var G=GlobalSpace;
	if (G.json_debug == 1)
		G.dataurl = "system.json";
		
	G.def_ajax_para.url=G.dataurl+'?id='+G.page_id +"&time="+ new Date().getTime();
	$.pbi_ajaxWrap('', G.def_ajax_para, onInitReceived);
}

$(function(){
	$("#verion_frame").ligerPanel({
		title : 'Version',
		width: 450,
		height: 160
	});
	$("#reset_frame").ligerPanel({
		title : 'Reboot Module',
		width: 450,
		height: 160
	});
	$("#reboot_frame").ligerPanel({
		title : 'Reboot/Default',
		width: 450,
		height: 160
	});
	$('#defaultPara').on({
		click:function (){
			$("#defaultBar").hide();
			$("#prompts").show();
			CommonFrame.confirm({
				id:"common_confirm_model",
				title: "",
				message: "Are you sure default parameters?(Device will restart.)",
				operate: function (result) {
					(result == true)?applyTypePara(GlobalSpace.DefaultFormId):console.log("Cancle default ");
				}
			});
		}
	});

	$("#selRetSon").multiselect({
		noneSelectedText: "==Please select==",
		checkAllText: "Select all",
		uncheckAllText: 'Unselect all',
		selectedList:0
	});

	$('#btnRetSon').on({
		click:function (){applyResetSonBoard();}
	});

	init_board_title();
	init_system();
});

/*
 function setup_tsoip(){
 var json_obj = {TSOIP_NET:{}},
 jsonStr = "",
 ajax_para={},
 temp_arr = [],
 i=0;

 if(!confirm('Save TS over IP Network setting?')){
 return 0;
 }

 json_obj.TSOIP_NET = GlobalSpace.TSOIP_NET;
 jsonStr= $.toJSON(json_obj);

 ajax_para.type = DEF.SEND_TYPE.GIVE;
 ajax_para.form_id = GlobalSpace.DEF_TSOIP_NET;
 ajaxWrap(jsonStr, apply_callback, ajax_para);
 }

 function setup_tsoip_mode(){
 var G = GlobalSpace,
 json_obj = {TSOIP_MODE:{}},
 jsonStr = "",
 ajax_para={};

 if(!confirm('Change Gigabit Mode?')){
 return 0;
 }

 G.TSOIP_MODE.value[DEF.TSOIP_MODE.TSIP_MODE] = $('#tsoip_mode').val();
 json_obj.TSOIP_MODE = GlobalSpace.TSOIP_MODE;
 jsonStr= $.toJSON(json_obj);

 ajax_para.type = DEF.SEND_TYPE.GIVE;
 ajax_para.form_id = GlobalSpace.DEF_TSOIP_MODE;
 ajaxWrap(jsonStr, apply_callback, ajax_para);
 }

 */